//More information at: https://www.aeq-web.com/
#include <SPI.h>
#include <Ethernet.h>
#include <Wire.h>
#include <cactus_io_BME280_I2C.h>

//////////////////////Please modify following lines///////////////////////
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xFD, 0xFD, 0xED };                    //
byte ip[] = { 10, 1, 1, 99 };                                           //
byte gateway[] = { 10, 1, 1, 254 };                                     //
byte subnet[] = { 255, 255, 255, 0 };                                   //
BME280_I2C bme(0x76);  // I2C address = 0x76                            //
//////////////////////////////////////////////////////////////////////////
EthernetServer server(80);                                              


float temp = 0;
float humidity = 0;


void setup() {
  Ethernet.begin(mac, ip, gateway, subnet);
  server.begin();
  Serial.begin(9600);
  if (!bme.begin()) {
    Serial.println("Could not receive values from sensor");
    temp = -128;
    humidity = -128;
  }
}

void loop() {

  EthernetClient client = server.available();
  if (client) {
    while (client.connected()) {
      readSensor();
      if (client.available()) {
          client.println("HTTP/1.1 200 OK"); //send new page
          client.println("Content-Type: text/html");
          client.println();
          client.println("<html>");
          client.println("<head>");
          client.println("<TITLE>Smarthome Temperature & Humidity Control</TITLE>");
          client.println("</head>");
          client.println("<body>");
          client.println("<h1>Temperature Station</h1>");
          client.println("<hr>");
          client.println("<br>");
          client.println("<table border='1'>");
          client.println("<tr>");
          client.println("<th>Temperature</th>");
          client.println("<th>");
          client.println(temp);
          client.println(" *C</th>");
          client.println("</tr>");
          client.println("<tr>");
          client.println("<th>Humidity</th>");
          client.println("<th>");
          client.println(humidity);
          client.println(" %</th>");
          client.println("</tr>");
          client.println("</table>");
          client.println("</body>");
          client.println("</html>");
          delay(10);
          client.stop();
      }
    }
  }
}
void readSensor(){  
  bme.readSensor();
  temp = bme.getTemperature_C();
  humidity = bme.getHumidity();
}
